glibmm: Gio::ProxyAddress Class Reference

glibmm 2.89.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gio::ProxyAddress Class Reference
Portable Network I/O Functionality

ProxyAddress - An internet address with proxy information. More...

`#include <giomm/proxyaddress.h>`

Inheritance diagram for Gio::ProxyAddress:
[legend]

## Public Member Functions
| ProxyAddress (ProxyAddress && src) noexcept
ProxyAddress & | operator= (ProxyAddress && src) noexcept
| ~ProxyAddress () noexcept override
GProxyAddress * | gobj ()
| Provides access to the underlying C GObject.
const GProxyAddress * | gobj () const
| Provides access to the underlying C GObject.
GProxyAddress * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::ustring | get_protocol () const
| Gets proxy's protocol.
Glib::ustring | get_destination_protocol () const
| Gets the protocol that is being spoken to the destination server; eg, "http" or "ftp".
Glib::ustring | get_destination_hostname () const
| Gets proxy's destination hostname; that is, the name of the host that will be connected to via the proxy, not the name of the proxy itself.
guint16 | get_destination_port () const
| Gets proxy's destination port; that is, the port on the destination host that will be connected to via the proxy, not the port number of the proxy itself.
Glib::ustring | get_username () const
| Gets proxy's username.
Glib::ustring | get_password () const
| Gets proxy's password.
Glib::ustring | get_uri () const
| Gets the proxy URI that proxy was constructed from.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_protocol () const
| The proxy protocol.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_destination_protocol () const
| The protocol being spoke to the destination host, or nullptr if the ProxyAddress doesn't know.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_destination_hostname () const
| The proxy destination hostname.
Glib::PropertyProxy_ReadOnly< guint > | property_destination_port () const
| The proxy destination port.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_username () const
| The proxy username.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_password () const
| The proxy password.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_uri () const
| The URI string that the proxy was constructed from (or nullptr if the creator didn't specify this).
Public Member Functions inherited from Gio::InetSocketAddress
| InetSocketAddress (InetSocketAddress && src) noexcept
InetSocketAddress & | operator= (InetSocketAddress && src) noexcept
| ~InetSocketAddress () noexcept override
GInetSocketAddress * | gobj ()
| Provides access to the underlying C GObject.
const GInetSocketAddress * | gobj () const
| Provides access to the underlying C GObject.
GInetSocketAddress * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< InetAddress > | get_address ()
| Gets address's InetAddress.
Glib::RefPtr< const InetAddress > | get_address () const
| Gets address's InetAddress.
guint16 | get_port () const
| Gets address's port.
guint32 | get_flowinfo () const
| Gets the sin6_flowinfo field from address, which must be an IPv6 address.
guint32 | get_scope_id () const
| Gets the sin6_scope_id field from address, which must be an IPv6 address.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< InetAddress > > | property_address () const
| The address.
Glib::PropertyProxy_ReadOnly< guint > | property_port () const
| The port.
Glib::PropertyProxy_ReadOnly< guint > | property_flowinfo () const
| The sin6_flowinfo field, for IPv6 addresses.
Glib::PropertyProxy_ReadOnly< guint > | property_scope_id () const
| The sin6_scope_id field, for IPv6 addresses.
Public Member Functions inherited from Gio::SocketAddress
| SocketAddress (SocketAddress && src) noexcept
SocketAddress & | operator= (SocketAddress && src) noexcept
| ~SocketAddress () noexcept override
GSocketAddress * | gobj ()
| Provides access to the underlying C GObject.
const GSocketAddress * | gobj () const
| Provides access to the underlying C GObject.
GSocketAddress * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
SocketFamily | get_family () const
| Gets the socket family type of address.
bool | to_native (gpointer dest, gsize destlen)
| Converts a SocketAddress to a native struct sockaddr, which can be passed to low-level functions like connect() or bind().
gssize | get_native_size () const
| Gets the size of address's native struct sockaddr.
Glib::PropertyProxy_ReadOnly< SocketFamily > | property_family () const
| The family of the socket address.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void * data)
void | set_data_with_c_callback (const Quark & key, void * data, GDestroyNotify notify)
void | set_data (const Quark & key, void * data, DestroyNotify notify)
| Prefer set_data_with_c_callback() with a callback with C linkage.
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::SocketConnectable
| SocketConnectable (SocketConnectable && src) noexcept
SocketConnectable & | operator= (SocketConnectable && src) noexcept
| ~SocketConnectable () noexcept override
GSocketConnectable * | gobj ()
| Provides access to the underlying C GObject.
const GSocketConnectable * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< SocketAddressEnumerator > | enumerate ()
| Creates a SocketAddressEnumerator for connectable.
Glib::RefPtr< const SocketAddressEnumerator > | enumerate () const
| Creates a SocketAddressEnumerator for connectable.
Glib::RefPtr< SocketAddressEnumerator > | proxy_enumerate ()
| Creates a SocketAddressEnumerator for connectable that will return a ProxyAddress for each of its addresses that you must connect to via a proxy.
Glib::RefPtr< const SocketAddressEnumerator > | proxy_enumerate () const
| Creates a SocketAddressEnumerator for connectable that will return a ProxyAddress for each of its addresses that you must connect to via a proxy.
Glib::ustring | to_string () const
| Format a SocketConnectable as a string.
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor.
| Interface (Interface && src) noexcept
Interface & | operator= (Interface && src) noexcept
| Interface (const Glib::Interface_Class & interface_class)
| Called by constructors of derived classes.
| Interface (GObject * castitem)
| Called by constructors of derived classes.
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< ProxyAddress > | create (const Glib::RefPtr< InetAddress > & address, guint16 port, const Glib::ustring & protocol, const Glib::ustring & destination_hostname, guint16 destination_port, const Glib::ustring & username={}, const Glib::ustring & password={})
Static Public Member Functions inherited from Gio::InetSocketAddress
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< InetSocketAddress > | create (const Glib::RefPtr< InetAddress > & address, guint16 port)
Static Public Member Functions inherited from Gio::SocketAddress
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< SocketAddress > | create (gpointer native, gsize len)
| Creates a SocketAddress subclass corresponding to the native struct sockaddr native.
Static Public Member Functions inherited from Gio::SocketConnectable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| ProxyAddress (const Glib::RefPtr< InetAddress > & address, guint16 port, const Glib::ustring & protocol, const Glib::ustring & destination_hostname, guint16 destination_port, const Glib::ustring & username={}, const Glib::ustring & password={})
Protected Member Functions inherited from Gio::InetSocketAddress
| InetSocketAddress (const Glib::RefPtr< InetAddress > & address, guint16 port)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)
Protected Member Functions inherited from Gio::SocketConnectable
| SocketConnectable ()
| You should derive from this class to use it.

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::ProxyAddress > | wrap (GProxyAddress * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::InetSocketAddress
Glib::RefPtr< Gio::InetSocketAddress > | wrap (GInetSocketAddress * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::SocketAddress
Glib::RefPtr< Gio::SocketAddress > | wrap (GSocketAddress * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)
Related Symbols inherited from Gio::SocketConnectable
Glib::RefPtr< Gio::SocketConnectable > | wrap (GSocketConnectable * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void (*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

ProxyAddress - An internet address with proxy information.

Support for proxied InetSocketAddress.

Since glibmm 2.28

## Constructor & Destructor Documentation

## ◆ ProxyAddress() [1/2]

Gio::ProxyAddress::ProxyAddress | ( | ProxyAddress && | src | ) |
| noexcept

## ◆ ~ProxyAddress()

Gio::ProxyAddress::~ProxyAddress | ( |  | ) |
| overridenoexcept

## ◆ ProxyAddress() [2/2]

Gio::ProxyAddress::ProxyAddress | ( | const Glib::RefPtr< InetAddress > & | address,
|  | guint16 | port,
|  | const Glib::ustring & | protocol,
|  | const Glib::ustring & | destination_hostname,
|  | guint16 | destination_port,
|  | const Glib::ustring & | username = {},
|  | const Glib::ustring & | password = {} )
| explicitprotected

## Member Function Documentation

## ◆ create()

Glib::RefPtr< ProxyAddress > Gio::ProxyAddress::create | ( | const Glib::RefPtr< InetAddress > & | address,
|  | guint16 | port,
|  | const Glib::ustring & | protocol,
|  | const Glib::ustring & | destination_hostname,
|  | guint16 | destination_port,
|  | const Glib::ustring & | username = {},
|  | const Glib::ustring & | password = {} )
| static

## ◆ get_destination_hostname()

Glib::ustring Gio::ProxyAddress::get_destination_hostname | ( |  | ) | const

Gets proxy's destination hostname; that is, the name of the host that will be connected to via the proxy, not the name of the proxy itself.

Since glibmm 2.26

Returns
  The proxy's destination hostname.

## ◆ get_destination_port()

guint16 Gio::ProxyAddress::get_destination_port | ( |  | ) | const

Gets proxy's destination port; that is, the port on the destination host that will be connected to via the proxy, not the port number of the proxy itself.

Since glibmm 2.26

Returns
  The proxy's destination port.

## ◆ get_destination_protocol()

Glib::ustring Gio::ProxyAddress::get_destination_protocol | ( |  | ) | const

Gets the protocol that is being spoken to the destination server; eg, "http" or "ftp".

Since glibmm 2.34

Returns
  The proxy's destination protocol.

## ◆ get_password()

Glib::ustring Gio::ProxyAddress::get_password | ( |  | ) | const

Gets proxy's password.

Since glibmm 2.26

Returns
  The proxy's password.

## ◆ get_protocol()

Glib::ustring Gio::ProxyAddress::get_protocol | ( |  | ) | const

Gets proxy's protocol.

eg, "socks" or "http"

Since glibmm 2.26

Returns
  The proxy's protocol.

## ◆ get_type()

GType Gio::ProxyAddress::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_uri()

Glib::ustring Gio::ProxyAddress::get_uri | ( |  | ) | const

Gets the proxy URI that proxy was constructed from.

Since glibmm 2.34

Returns
  The proxy's URI, or nullptr if unknown.

## ◆ get_username()

Glib::ustring Gio::ProxyAddress::get_username | ( |  | ) | const

Gets proxy's username.

Since glibmm 2.26

Returns
  The proxy's username.

## ◆ gobj() [1/2]

GProxyAddress * Gio::ProxyAddress::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GProxyAddress * Gio::ProxyAddress::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GProxyAddress * Gio::ProxyAddress::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

ProxyAddress & Gio::ProxyAddress::operator= | ( | ProxyAddress && | src | ) |
| noexcept

## ◆ property_destination_hostname()

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::ProxyAddress::property_destination_hostname | ( |  | ) | const

The proxy destination hostname.

Since glibmm 2.26

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_destination_port()

Glib::PropertyProxy_ReadOnly< guint > Gio::ProxyAddress::property_destination_port | ( |  | ) | const

The proxy destination port.

Since glibmm 2.26

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_destination_protocol()

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::ProxyAddress::property_destination_protocol | ( |  | ) | const

The protocol being spoke to the destination host, or nullptr if the ProxyAddress doesn't know.

Since glibmm 2.34

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_password()

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::ProxyAddress::property_password | ( |  | ) | const

The proxy password.

Since glibmm 2.26

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_protocol()

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::ProxyAddress::property_protocol | ( |  | ) | const

The proxy protocol.

Since glibmm 2.26

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_uri()

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::ProxyAddress::property_uri | ( |  | ) | const

The URI string that the proxy was constructed from (or nullptr if the creator didn't specify this).

Since glibmm 2.34

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_username()

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::ProxyAddress::property_username | ( |  | ) | const

The proxy username.

Since glibmm 2.26

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::ProxyAddress > wrap | ( | GProxyAddress * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.